<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Release Notes &mdash; Medusa Nodes 1.1.0-beta documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
    <link rel="shortcut icon" href="_static/medusa_nodes_favicon.ico"/>
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="author" title="About these documents" href="about.html" />
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Installation" href="installation.html" />
    <link rel="prev" title="About" href="about.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> Medusa Nodes
            <img src="_static/medusa_node_logo_animation_003.gif" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.1.0-beta
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="about.html">About</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Release Notes</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#introduction">Introduction</a></li>
<li class="toctree-l2"><a class="reference internal" href="#freezing-system">Freezing System</a></li>
<li class="toctree-l2"><a class="reference internal" href="#simulation-experimental">Simulation (Experimental)</a></li>
<li class="toctree-l2"><a class="reference internal" href="#speed-improvements">Speed Improvements</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#comparison-with-blender">Comparison with Blender</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#surface-deformation">Surface Deformation</a></li>
<li class="toctree-l2"><a class="reference internal" href="#new-nodes">New Nodes</a></li>
<li class="toctree-l2"><a class="reference internal" href="#node-improvements">Node Improvements</a></li>
<li class="toctree-l2"><a class="reference internal" href="#improved-groom-initialization">Improved Groom Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="#ui-and-functionality">UI and Functionality</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="introduction.html">Introduction</a></li>
<li class="toctree-l1"><a class="reference internal" href="nodes.html">Nodes</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Medusa Nodes</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a></li>
      <li class="breadcrumb-item active">Release Notes</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/release_notes.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="release-notes">
<span id="id1"></span><h1>Release Notes<a class="headerlink" href="#release-notes" title="Permalink to this headline"></a></h1>
<p class="linemarker linemarker-6">v1.1.0-beta</p>
<figure class="align-center">
<a class="reference internal image-reference" href="_images/clump_sim_001.gif"><img alt="Basic Clump Simulation" src="_images/clump_sim_001.gif" style="width: 500px;" /></a>
</figure>
<hr class="docutils" />
<section id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline"></a></h2>
<p class="linemarker linemarker-18">This release enhances performance and functionality across key nodes such as <strong>Generator</strong>, <strong>Guide</strong>, <strong>Clump</strong>, <strong>Noise</strong>, and <strong>Trim</strong>, with significant speed improvements, undergoing multiple redesigns over a 14-month period for enhanced performance.
New nodes like, <a class="reference internal" href="nodes/scale.html#scale"><span class="std std-ref">Scale</span></a>, <a class="reference internal" href="nodes/resample_hair.html#resample-hair"><span class="std std-ref">Resample Hair</span></a>, and <a class="reference internal" href="nodes/curves_to_splines.html#curves-to-splines"><span class="std std-ref">Curves to Splines</span></a> have been added.</p>
<p class="linemarker linemarker-21">A manual <strong>Freezing System</strong> minimizes redundant calculations, improving sculpting processes and procedural modeling speed.</p>
<p class="linemarker linemarker-23">Users can now <strong>sculpt</strong> directly on <strong>frozen Guides</strong> and set up animated <strong>surface deformation</strong> more easily.</p>
<p class="linemarker linemarker-25">Additionally, a new <a class="reference internal" href="nodes/dynamics.html#dynamics"><span class="std std-ref">Dynamics</span></a> node introduces experimental <strong>physics simulation</strong> capabilities, offering users adjustable parameters for gravity, stretchiness, damping, stiffness and collision.</p>
<p class="linemarker linemarker-27">Various structural <strong>UI design improvements</strong> have also been implemented.</p>
</section>
<section id="freezing-system">
<h2>Freezing System<a class="headerlink" href="#freezing-system" title="Permalink to this headline"></a></h2>
<p class="linemarker linemarker-32">Manual <strong>freezing</strong> of generated splines (hair follicles) within the <strong>Generator</strong> now <strong>minimizes redundant calculations</strong>, providing a substantial performance boost by eliminating the need for repeated spline generation on <strong>each dependency graph update</strong>.
The Freezing System extends to <strong>Guide</strong>, <strong>Noise</strong>, <strong>Curl</strong>, and <strong>Curves to Splines</strong> nodes, making the <strong>hair deformation</strong> during  <strong>sculpting</strong> and <strong>procedural modeling faster</strong>.</p>
<dl>
<dt>Freezing - Sculpt on Frozen Guides</dt><dd><p class="linemarker linemarker-36"><a class="reference internal" href="_images/sculpt_mode_toggle_button_001.jpg"><img alt="Sculpt Mode Toggle Button" src="_images/sculpt_mode_toggle_button_001.jpg" style="height: 200px;" /></a></p>
<p class="linemarker linemarker-38">Users can now <strong>sculpt</strong> directly on <strong>frozen Guides</strong>. Once splines are distributed on the <strong>Guide</strong> object,
entering sculpt mode via the <em>Sculpt Mode Toggle</em> button This action freezes the Generator, rendering most parameters inaccessible (grayed-out).</p>
</dd>
</dl>
<video class = generic_vid autoplay controls width="100%" height="100%" preload="metadata" poster = ./_static/images/freezing_demo_thumbnail.jpg>
    <source src="./_static/videos/release_notes_v1.1.0-beta/freezing_demo_003.mp4" type="video/mp4">
    Your browser does not support the video tag.
</video><p class="linemarker linemarker-57"> </p>
<dl class="simple">
<dt>Freezing - Key Features</dt><dd><ul class="simple">
<li><p class="linemarker linemarker-64"><strong>Sculpting:</strong> Ability to sculpt on frozen splines.</p></li>
<li><p class="linemarker linemarker-65"><strong>Single generation:</strong> Splines can be generated and <strong>“made real”</strong>.</p></li>
<li><p class="linemarker linemarker-66"><strong>Faster animation and simulation:</strong> Freezing splines in the <strong>Generator</strong> and subsequent freezing of nodes like <strong>Guide</strong> and <strong>Noise</strong> makes the animation playback as well as the simulation faster. (Requires testing)</p></li>
<li><p class="linemarker linemarker-67"><strong>Reduced calculation times:</strong> Precalculated attributes are automatically stored on <strong>Hair</strong> and <strong>Guide</strong> objects upon freezing selected nodes, <strong>eliminating repetitive noise</strong> or <strong>interpolation algorithm</strong> computations. (Requires testing)</p></li>
</ul>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p class="linemarker linemarker-70">Scene <strong>size</strong> significantly <strong>increases</strong> due to the frozen splines being <strong>“baked”</strong> <strong>directly into</strong> the hair object, rather than being procedurally generated.
This is particularly the case in scenarios with multiple Medusa Nodes’ grooms containing <strong>hundreds of thousands of splines</strong>.</p>
</div>
</section>
<section id="simulation-experimental">
<h2>Simulation (Experimental)<a class="headerlink" href="#simulation-experimental" title="Permalink to this headline"></a></h2>
<video class = generic_vid autoplay controls width="100%" height="100%" preload="metadata" poster = ./_static/images/dynamics_demo_thumbnail.jpg>
    <source src="./_static/videos/release_notes_v1.1.0-beta/dynamics_demo_001.mp4" type="video/mp4">
    Your browser does not support the video tag.
</video><p class="linemarker linemarker-87"> </p>
<p class="linemarker linemarker-101">A new <strong>Dynamics</strong> node has been introduced, utilizing a <strong>physical dynamics solver</strong> using <a class="reference external" href="https://en.wikipedia.org/wiki/Verlet_integration">Verlet Integration</a>. While not entirely realistic, it provides functionality comparable to simpler game physics engines.</p>
<dl class="simple">
<dt>Dynamics - Key Features</dt><dd><ul class="simple">
<li><p class="linemarker linemarker-104">Users have the ability to adjust various parameters such as <strong>gravity</strong>, <strong>stretchiness</strong>, <strong>damping</strong>, and <strong>stiffness</strong> using different <strong>Mask Groups</strong>.</p></li>
<li><p class="linemarker linemarker-105">Additionally, enabling the <strong>Collision</strong> with <strong>Emitter Object</strong> option allows users to <strong>choose</strong> between the <strong>emitter object</strong> or <strong>specific mesh objects</strong> within a designated <strong>Collision collection</strong>.</p></li>
<li><p class="linemarker linemarker-106">Furthermore, the <strong>physics simulation</strong> accounts for <strong>surface deformations</strong> of the emitter object, ensuring that changes in its surface influence the simulated hair accordingly.</p></li>
</ul>
</dd>
</dl>
<blockquote class="twitter-tweet" data-media-max-width="800" data-dnt="true"><p lang="en" dir="ltr">Medusa Nodes update on the horizon! New additions include custom geometry nodes physics solver with collision, and shape preservation options. <a href="https://twitter.com/hashtag/MedusaNodes?src=hash&amp;ref_src=twsrc%5Etfw">#MedusaNodes</a> <a href="https://twitter.com/hashtag/Blender?src=hash&amp;ref_src=twsrc%5Etfw">#Blender</a> <a href="https://twitter.com/hashtag/geometrynodes?src=hash&amp;ref_src=twsrc%5Etfw">#geometrynodes</a> <a href="https://t.co/hr2jBVnB0I">pic.twitter.com/hr2jBVnB0I</a></p>&mdash; Irakli Kupunia (@KupuniaIrakli) <a href="https://twitter.com/KupuniaIrakli/status/1753170924633837859?ref_src=twsrc%5Etfw">February 1, 2024</a></blockquote><script async src="https://platform.twitter.com/widgets.js" charset="utf-8"></script><p class="linemarker linemarker-113"> </p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p class="linemarker linemarker-116">Please keep in mind that the <strong>Dynamics</strong> node is <strong>experimental</strong> and may exhibit some bugs.</p>
</div>
</section>
<section id="speed-improvements">
<h2>Speed Improvements<a class="headerlink" href="#speed-improvements" title="Permalink to this headline"></a></h2>
<section id="comparison-with-blender">
<h3>Comparison with Blender<a class="headerlink" href="#comparison-with-blender" title="Permalink to this headline"></a></h3>
<p class="linemarker linemarker-126">While improving <strong>Medusa Nodes’</strong> performance in relation to the addon’s previous version is valuable, the real significance lies in comparing it with Blender’s new <a class="reference external" href="https://en.wikipedia.org/wiki/Verlet_integration">geometry nodes based hair system</a> and its versatile nodes. These systems are quite different, and comparisons of such kinds sometimes tend to highlight obvious advantages of one system over the other, while simultaneously leaving out the shortcomings.</p>
<p class="linemarker linemarker-128">With that said, the comparison tests shown below only highlight a part of both systems, particularly the <strong>distribution</strong> and <strong>interpolation</strong>.</p>
<dl>
<dt>Comparison with Blender - Differences</dt><dd><p class="linemarker linemarker-131">The way Medusa Nodes works internally is quite different from native hair nodes in Blender.</p>
<dl>
<dt>Blender</dt><dd><p class="linemarker linemarker-134">Blender’s <strong>Interpolate Hair Curves</strong> <a class="reference internal" href="_images/interpolate_hair_curves_001.jpg"><img alt="Interpolate Hair Curves Icon" src="_images/interpolate_hair_curves_001.jpg" style="height: 40px;" /></a> modifier is responsible for <strong>simultaneous</strong> <strong>distribution</strong> and <strong>interpolation</strong> of hair curves.</p>
<p class="linemarker linemarker-136">The modifier offers two distribution methods: <strong>Random Distribution</strong> and <strong>Poisson Disk Distribution</strong>, the latter being slower but also more accurate as it mimics the organic distribution of hair follicles on skin.</p>
<p class="linemarker linemarker-138">The modifier can account for <strong>length</strong>, <strong>shape</strong>, and <strong>point count</strong> of parent curves in close proximity.
This is quite artist-friendly, as users don’t really have to think about <strong>point count</strong>.</p>
</dd>
<dt>Medusa Nodes</dt><dd><p class="linemarker linemarker-142">In Medusa Nodes, the <strong>distribution</strong> and <strong>interpolation</strong> are split up into two different modifiers: <strong>Generator</strong> and <strong>Guide</strong>.</p>
<p class="linemarker linemarker-144">The <strong>Generator</strong> <a class="reference internal" href="_images/generator_icon_001.jpg"><img alt="Generator Icon" src="_images/generator_icon_001.jpg" style="height: 40px;" /></a> modifier is responsible for the distribution of hair follicles. Both of the above distribution methods are present here as well (additionally, there are 2 more methods of distribution: <strong>Exact Amount Distribution</strong> and <strong>Distribute on Vertices</strong>).</p>
<p class="linemarker linemarker-146">The <strong>Guide</strong> <a class="reference internal" href="_images/guide_icon_001.jpg"><img alt="Guide Icon" src="_images/guide_icon_001.jpg" style="height: 40px;" /></a> modifier interpolates the length and shape of parent curves in close proximity. It does not account for differences in point count. It automatically sets the same point count for each and every spline.</p>
<p class="linemarker linemarker-148">Fortunately, partially because of this lacking functionality, <strong>animated surface hair deformation</strong> as well as hair curves sculpting can <strong>calculate faster</strong>.</p>
</dd>
</dl>
</dd>
</dl>
<table class="borderless docutils align-default" id="id2" style="width: 100%">
<caption><span class="caption-text"><strong>FPS comparison with regular Blender hair curves object</strong></span><a class="headerlink" href="#id2" title="Permalink to this table"></a></caption>
<colgroup>
<col style="width: 50%" />
<col style="width: 50%" />
</colgroup>
<tbody>
<tr class="row-odd"><td><figure class="align-center" id="id3">
<a class="reference internal image-reference" href="_images/poisson_disk_distribution_comparison.svg"><img alt="_images/poisson_disk_distribution_comparison.svg" src="_images/poisson_disk_distribution_comparison.svg" width="100%" /></a>
<figcaption>
<p><span class="caption-text">Chart 1</span><a class="headerlink" href="#id3" title="Permalink to this image"></a></p>
</figcaption>
</figure>
</td>
<td><figure class="align-center" id="id4">
<a class="reference internal image-reference" href="_images/random_distribution_comparison.svg"><img alt="_images/random_distribution_comparison.svg" src="_images/random_distribution_comparison.svg" width="100%" /></a>
<figcaption>
<p><span class="caption-text">Chart 2</span><a class="headerlink" href="#id4" title="Permalink to this image"></a></p>
</figcaption>
</figure>
</td>
</tr>
</tbody>
</table>
<ul class="simple">
<li><p class="linemarker linemarker-200"><strong>Chart 1:</strong> 30 FPS. 30 Frame animation with Iso sphere geometry used as an emitting surface. Both of the setups use same amount of randomly distributed guiding splines (59)</p></li>
<li><p class="linemarker linemarker-203"><strong>Chart 2:</strong> 30 FPS. 30 Frame animation with Iso sphere geometry used as an emitting surface. Both: Blender hair Curves Object and Medusa Nodes Hair object of the setups use same amount of randomly distributed guiding splines (59)</p></li>
</ul>
<video controls width="100%" height="100%">
    <source src="./_static/videos/release_notes_v1.1.0-beta/frozen_comparison_with_blender_003.mp4" type="video/mp4">
    Your browser does not support the video tag.
</video><p class="linemarker linemarker-219"> </p>
</section>
</section>
<section id="surface-deformation">
<h2>Surface Deformation<a class="headerlink" href="#surface-deformation" title="Permalink to this headline"></a></h2>
<p class="linemarker linemarker-227">Enabling hair deformation based on animated surfaces deformation has been a highly requested feature, previously lacking and cumbersome to configure.</p>
<p class="linemarker linemarker-229">Now, surface deformation is easily activated by selecting the <strong>Surface Deform</strong> option in the <strong>Generator</strong> (ensure to enable it on the <strong>Guide Object’s Generator</strong> as well).</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p class="linemarker linemarker-232"><strong>Surface Deform</strong> option has some <strong>additional calculation overhead</strong>; avoid enabling it unless necessary.</p>
</div>
</section>
<section id="new-nodes">
<h2>New Nodes<a class="headerlink" href="#new-nodes" title="Permalink to this headline"></a></h2>
<p class="linemarker linemarker-238">New <strong>Utility</strong> nodes, such as <strong>Curves to Spline</strong>, <strong>Mirror</strong>, <strong>Scale</strong>, and <strong>Resample Hair</strong>, have been added. These nodes might be useful in some specific scenarios.</p>
</section>
<section id="node-improvements">
<h2>Node Improvements<a class="headerlink" href="#node-improvements" title="Permalink to this headline"></a></h2>
<dl>
<dt><strong>Generator Node</strong></dt><dd><ul class="simple">
<li><p class="linemarker linemarker-247">The freezing system caches generated splines and allows <strong>sculpting</strong>.</p></li>
<li><p class="linemarker linemarker-248"><strong>Speed improvements</strong> are observed with the Generator’s <strong>Poison Disk Distribution</strong>, especially when used with frozen splines.</p></li>
<li><p class="linemarker linemarker-249">Additionally, the <strong>Interpolation Object</strong> option has been added.</p></li>
</ul>
<dl class="simple">
<dt>Interpolation Object Option</dt><dd><ul class="simple">
<li><p class="linemarker linemarker-252">Now, users can select an interpolation object within the scene, enabling the generation of splines replicating the shape and length of the chosen hair object.</p></li>
</ul>
</dd>
</dl>
</dd>
<dt><strong>Clump Node</strong></dt><dd><ul class="simple">
<li><p class="linemarker linemarker-255">The <strong>Clump</strong> deformer properties have been reorganized in an upgraded <strong>sub-panel UI</strong>, improving user experience.</p></li>
<li><p class="linemarker linemarker-256">Now it <strong>efficiently</strong> distributes <strong>higher amounts of clumps</strong>, reducing calculation times.</p></li>
<li><p class="linemarker linemarker-257">Introducing <strong>Clump Cell Randomness</strong> brings variability to clump thickness for a more realistic appearance.</p></li>
<li><p class="linemarker linemarker-258">The <strong>Volumize</strong> parameter in the <strong>Misc</strong> sub-panel mimics Blender’s <strong>Clump Hair Curves</strong> modifier’s clump shape.</p></li>
</ul>
</dd>
<dt><strong>Guide Node</strong></dt><dd><ul class="simple">
<li><p class="linemarker linemarker-261">The <strong>Guide</strong> deformer now calculates <strong>faster</strong>, particularly when used with <strong>Region Maps</strong> (testing required).</p></li>
<li><p class="linemarker linemarker-262"><strong>Freezing</strong> stores pre-calculated data, enabling faster hair deformation processes.</p></li>
</ul>
</dd>
</dl>
</section>
<section id="improved-groom-initialization">
<h2>Improved Groom Initialization<a class="headerlink" href="#improved-groom-initialization" title="Permalink to this headline"></a></h2>
<p class="linemarker linemarker-268">The initial <strong>New Groom</strong> pop-up displays <strong>approximate spline</strong> and <strong>control point counts</strong>, starting with a default distribution of around <strong>10,000</strong> splines for any chosen mesh geometry.
Also, the <strong>thickness</strong> and <strong>length</strong> of distributed splines are calculated based on emitter geometry’s <strong>surface area</strong> and <strong>dimensions</strong>, allowing for better adaptability across various geometries.</p>
</section>
<section id="ui-and-functionality">
<h2>UI and Functionality<a class="headerlink" href="#ui-and-functionality" title="Permalink to this headline"></a></h2>
<p class="linemarker linemarker-276">The separation of the new <strong>Medusa Nodes Properties</strong> panel from the <strong>Medusa Nodes Hierarchy</strong> optimizes vertical screen space, enabling users to efficiently adjust parameters of larger nodes.</p>
<dl class="simple">
<dt><strong>Icons</strong></dt><dd><p class="linemarker linemarker-279">New icons differentiate node types in both the <strong>Hierarchy</strong> and <strong>Properties</strong> panels, as well as in the <strong>Mask Group Options</strong> menu. <strong>Main</strong> hierarchy icons remain <strong>white</strong>, while <strong>secondary</strong> hierarchy icons are <strong>green</strong>, aligning with the default color of <strong>guides</strong>, for clear visual organization.</p>
</dd>
</dl>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="about.html" class="btn btn-neutral float-left" title="About" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="installation.html" class="btn btn-neutral float-right" title="Installation" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, Medusa Nodes.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>